local Enabled = false
Crosshair_Color = "red"
Crosshair_Size = "big"

Crosshair_Colors = {
	["red"] = Color( 255, 0, 0, 255 ),
	["green"] = Color( 0, 255, 0, 255 ),
	["blue"] = Color( 0, 0, 255, 255 ),
	["cyan"] = Color( 0, 255, 255, 255 ),
	["yellow"] = Color( 255, 255, 0, 255 ),
	["pink"] = Color( 255, 0, 255, 255 ),
	["white"] = Color( 255, 255, 255, 255 ),
	["black"] = Color( 0, 0, 0, 255 ),
	["dark gray"] = Color( 75, 75, 75, 255 ),
	["gray"] = Color( 125, 125, 125, 255 ),
	["light gray"] = Color( 175, 175, 175, 255 )
}

Crosshair_Sizes = {
	["very big"] = 15,
	["big"] = 10,
	["medium"] = 7,
	["small"] = 5,
	["very small"] = 3
}

function Toggle_View()

	Enabled = not Enabled
	
	if ( Enabled ) then
	
		hook.Add( "CalcView", "ShoulderView", ShoulderView )
		hook.Add( "HUDPaint", "HUDPaint", DrawCrosshair )
		hook.Add( "ShouldDrawLocalPlayer", "ShouldDrawLocalPlayer", DrawLocalPlayer )
		
	else
	
		hook.Remove( "CalcView", "ShoulderView" )
		hook.Remove( "HUDPaint", "HUDPaint" )
		hook.Remove( "ShouldDrawLocalPlayer", "ShouldDrawLocalPlayer" )
	
	end

end
concommand.Add( "shoulderview_toggle", Toggle_View )

function Menu()

	local frame = vgui.Create( "DFrame" )
	frame:SetSize( 200, 200 )
	frame:Center()
	frame:SetTitle( "Crosshair options" )
	frame:MakePopup()
	
	local size = vgui.Create( "DComboBox", frame )
	size:SetPos( 5, 27 )
	size:SetTall( 140 )
	size:SetWide( 90 )
	size:SetMultiple( false )

	for k, v in pairs ( Crosshair_Sizes ) do
	
		size:AddItem( k )
		
	end
	
	size:SelectByName( Crosshair_Size )
	
	local color = vgui.Create( "DComboBox", frame )
	color:SetPos( 100, 27 )
	color:SetTall( 140 )
	color:SetWide( 95 )
	color:SetMultiple( false )

	for k, v in pairs ( Crosshair_Colors ) do
	
		color:AddItem( k )
		
	end
	
	color:SelectByName( Crosshair_Color )
	
	local ok = vgui.Create( "DButton", frame )
	ok:SetText( "OK" )
	ok:SetPos( 5, 170 )
	ok:SetWide( 190 )
	ok.DoClick = function()

		Crosshair_Size = size:GetSelectedItems()[1]:GetValue()
		Crosshair_Color = color:GetSelectedItems()[1]:GetValue()
		
		frame:Close()

	end

end
concommand.Add( "shoulderview_menu", Menu )

function ShoulderView( ply, pos, angles, fov )

	if ( Enabled ) then

		local view = {}
		view.origin = pos - ( angles:Forward() * 50 ) + ( angles:Right() * 25 )
		view.angles = angles
		view.fov = fov

		return view
	
	end

end

function DrawCrosshair()

	if ( Enabled ) then
	
        local tr = util.GetPlayerTrace( LocalPlayer() )
        tr.mask = ( CONTENTS_SOLID | CONTENTS_MOVEABLE | CONTENTS_MONSTER | CONTENTS_WINDOW | CONTENTS_DEBRIS | CONTENTS_GRATE | CONTENTS_AUX )
        local trace = util.TraceLine( tr )
        
        local coords = trace.HitPos:ToScreen()
        x, y = coords.x, coords.y
		
		local scale = ScreenScale( Crosshair_Sizes[Crosshair_Size] )
		
		surface.SetDrawColor( Crosshair_Colors[Crosshair_Color] )
		surface.DrawLine( x, y - scale, x, y + scale )
		surface.DrawLine( x - scale, y, x + scale, y )
		surface.DrawCircle( x, y, scale, Crosshair_Colors[Crosshair_Color] )

	end

end

function DrawLocalPlayer( ply )

	if ( Enabled ) then

		return true

	else

		return false

	end

end